function [L,M,lambda,mu,realFlag] = linesJunctionExtraction(XiL,XiM)


A_L = [XiL(4:6,:)' XiL(1:3,:)'];
A_M = [XiM(4:6,:)' XiM(1:3,:)'];

[~,~,VL] = svd(A_L);
[~,~,VM] = svd(A_M);

L0 = VL(:,end);
L1 = VL(:,end-1);
L2 = VL(:,end-2);

M0 = VM(:,end);
M1 = VM(:,end-1);
M2 = VM(:,end-2);

%L = L0 + L1*lambda1+L2*lambda2
%M = M0 + M1*mu1+M2*mu2

L_m = [L0 L1 L2];
M_m = [M0 M1 M2];
if L_m(3,1)<0, L_m = - L_m;end;
if M_m(3,1)<0, M_m = - M_m;end;

%% Compute the 8 degree single equation in mu1;
C_Eq = computeQuarticEquation(L_m,M_m);
CC = getCoefs8Degree(C_Eq,M_m);

mu1 = roots(CC')';

%% You get 8 solutions


mu2Plus = zeros(1,8);
mu2Minus = zeros(1,8);
for k = 1:numel(mu1)
    [mu2Plus(k), mu2Minus(k)] = getMu2FromMu1(mu1(k),M_m);        
end

mu = [[ones(1,numel(mu1));mu1;mu2Plus],[ones(1,numel(mu1));mu1;mu2Minus]];
[lambda,C,muHat]= computeLambdaFromMu(L_m,M_m,mu(1,:),mu(2,:),mu(3,:));

realFlag = sum(imag(mu)==0)==3;


L = L_m*lambda;
M = M_m*mu;



return;

