function [distv, distn, distd, votes] = getPluckerLineErrors(LAcum,LRef)

LAcum = [LAcum,-LAcum];

normLAcum = sqrt(LAcum(1,:).^2+LAcum(2,:).^2+LAcum(3,:).^2);
LAcum = bsxfun(@rdivide,LAcum,normLAcum);

LRef = LRef/norm(LRef(1:3));

lAcum = LAcum(1:3,:);
lBarAcum = LAcum(4:6,:);
dAcum = sqrt(lBarAcum(1,:).^2+lBarAcum(2,:).^2+lBarAcum(3,:).^2);

nAcum = bsxfun(@rdivide,lBarAcum,dAcum);

lRef = LRef(1:3);
lBarRef = LRef(4:6);
dRef = norm(lBarRef);
nRef = lBarRef/dRef;

cosDistv = abs(lRef'*lAcum);
cosDistn = abs(nRef'*nAcum);

cosDistv(cosDistv>1) = 1;
cosDistn(cosDistn>1) = 1;

distv = acos(cosDistv);
distn = acos(cosDistn);
distd = abs(dAcum-dRef);


if ~isreal(distv)
   disp('no real'); 
end

iv = find(distv==min(distv));
in = find(distn==min(distn));
id = find(distd==min(distd));

votes = zeros(1,size(LAcum,2));

votes(iv) = votes(iv)+1;
votes(in) = votes(in)+1;
votes(id) = votes(id)+1;

return;