function [xI, m, ii, errorFlag] = singleForwardSphereProjectionUp(X,d,r)

errorFlag = 0;
if ~isreal(X)
    disp('No real');
    X = real(X);
    errorFlag = 2;
end


%% Change of reference of the point in euclidean
P = X(1:3)/X(4);

if norm(P)<r || ~isreal(P)
   disp('norm(P)<r'); 
   errorFlag = 1;
end



if ~exist('paint','var')
   paint = 0; 
end

u = sqrt(P(1)^2+P(2)^2);
v = P(3);

polyc(1) = 4*d^2*(u^2 + v^2);
polyc(2) = -4*d*r^2*(u^2 + v^2 + d*v);
polyc(3) = r^2*(d^2*r^2 - 4*d^2*u^2 - 4*d^2*v^2 + 2*d*r^2*v + r^2*u^2 + r^2*v^2);
polyc(4) = 2*d*r^4*(u^2 + 2*v^2 + 2*d*v);
polyc(5) = - d^2*r^6 + d^2*r^4*u^2 - 2*d*r^6*v - r^6*v^2;

y = roots(polyc)';

if ~isreal(y)
   binImag = imag(y)~=0;
   
   yReal = real(y(binImag));
   yImag = imag(y(binImag));
   
   if (sum(binImag) == 2) && (sum(yImag<1e-5)==2) && (yReal(1)==yReal(2))       
       y = [yReal(1),y(~binImag)];
       disp('Este caso');
   end
end

x = sign(u)*sqrt(r^2-y.^2);

m = [x;y];

%Construct v_i

v_i = [x;y-d];
v_r = [u-x;v-y];

% Sphere is trivial
n = [x;y];

% v_r'*n
nNorm = sqrt(n(1,:).^2+n(2,:).^2);
v_iNorm = sqrt(v_i(1,:).^2+v_i(2,:).^2);
v_rNorm = sqrt(v_r(1,:).^2+v_r(2,:).^2);



cosgammaA = dot([v_i(1,:)./v_iNorm;v_i(2,:)./v_iNorm],[n(1,:)./nNorm;n(2,:)./nNorm]);
cosgammaB = dot([v_r(1,:)./v_rNorm;v_r(2,:)./v_rNorm],[n(1,:)./nNorm;n(2,:)./nNorm]);
res = abs(cosgammaA+cosgammaB);

ii = find(res==min(res));

if paint==1
    figure(1);
    axis equal;
    hold on;
    plot(0,0,'r*');
    plot(0,d,'bo');
    plot(u,v,'b*');

    theta = -pi:pi/180:pi;
    plot(r*cos(theta),r*sin(theta),'g-');

    for k = 1:numel(x);
        line([0 x(k)],[d y(k)]);
        line([x(k) u],[y(k) v]);    
        line([x(k) x(k)+n(1,k)],[y(k) y(k)+n(2,k)],'Color','r');
    end

    line([0 x(ii)],[d y(ii)],'Color','g');
    line([x(ii) u],[y(ii) v],'Color','g');    
    line([x(ii) x(ii)+n(1,ii)],[y(ii) y(ii)+n(2,ii)],'Color','r');
end



phi = atan2(P(2),P(1));
xI = [x(ii(1))*cos(phi);x(ii(1))*sin(phi);y(ii(1))];

return;
